#include-once
#include <stack00.au3>

; Wir Erzeugen einen Stack mit der Nr. $n
$n = inistack()

; und legen 10 Zufallszalen auf diesen Stack
for $i = 1 to 10 ;
   push($n,Random(-10, 10, 1))
next

; So sieht der Stack dann aus
stack2box($n,'10 Zufallszahlen aus [-10...10]')

; Zuweisen des ersten Elements noch $dummy, dieses Element wird vom Stack genommen
$dummy = pop($n)
msgbox(0,'$dummy = pop($n)','$dummy='&$dummy)
stack2box($n,'9 Zufallszahlen aus [-10...10]')

; Einige weitere Funktionen
pick($n,5)
stack2box($n,'5. Element mit PICK($n,5) auf an 1. Stelle kopiert')
roll($n,5)
stack2box($n,'5. Element mit PICK($n,5) auf an 1. Stelle verschoben')
dup($n)
stack2box($n,'1. Element mit DUP($n) kopiert')
rot($n)
stack2box($n,'3. Element mit ROT($n) kopiert')
swap($n)
stack2box($n,'1. und 2. Element mit SWAP($n) getauscht')
over($n)
stack2box($n,'2. Element mit ROT($n) kopiert')
drop($n)
stack2box($n,'1. Element mit DROP($n) gelscht')
minimax($n,0)
stack2box($n,'Kleinstes Element an 1. Stelle mit MINIMAX($n,0)')
minimax($n,1)
stack2box($n,'Grtes Element an 1. Stelle mit MINIMAX($n,1)')
stacksort($n,0)
stack2box($n,'Ges. STACK aufsteigend sortiert mit STACKSORT($n,0)')
stacksort($n,1)
stack2box($n,'Ges. STACK absteigend sortiert mit STACKSORT($n,1)')
stackrevers($n)
stack2box($n,'Ges. STACK umgekehrt mit STACKREVERS($n)')

; Stack $n in nach $dummy, danach ist der Stack leer!
$dummy = ''
while eos($n)
   $dummy = $dummy&pop($n)&','
wend
msgbox(0,'$dummy&pop($n)','$dummy='&$dummy)

; Z.B. ablegen, sortieren und anzeigen des 
; Verzeichnislisting @HomeDrive mit dem Stack
$search = FileFindFirstFile(@HomeDrive&"\*.*")
If $search = -1 Then
    MsgBox(0, "Error", "No files/directories matched the search pattern")
    Exit
EndIf
While 1
    $dummy = FileFindNextFile($search)
    If @error Then ExitLoop
    push($n,$dummy)
WEnd
FileClose($search)
stacksort($n,0)
stack2box($n,'Verzeichnislisting '&@HomeDrive&' aufsteigend geordnet')

exit